import * as i0 from "@angular/core";
/**
 * A directive for applying styling to an input element.
 *
 * Example:
 *
 * ```html
 * <input ofeTextInput/>
 * ```
 *
 * See the [vanilla carbon docs](http://www.carbondesignsystem.com/components/text-input/code) for more detail.
 */
export declare class TextInputDirective {
    /**
     * `light` or `dark` input theme
     */
    theme: 'light' | 'dark';
    /**
     * Input field render size
     */
    size: 'sm' | 'md' | 'xl';
    inputClass: boolean;
    get isSizeXl(): boolean;
    get isSizeSm(): boolean;
    invalid: boolean;
    warn: boolean;
    skeleton: boolean;
    get isLightTheme(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<TextInputDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TextInputDirective, "[ofeTextInput]", never, { "theme": { "alias": "theme"; "required": false; }; "size": { "alias": "size"; "required": false; }; "invalid": { "alias": "invalid"; "required": false; }; "warn": { "alias": "warn"; "required": false; }; "skeleton": { "alias": "skeleton"; "required": false; }; }, {}, never, never, false, never>;
}
