import * as i0 from "@angular/core";
/**
 * A directive for applying styling to a textarea element.
 *
 * Example:
 *
 * ```html
 * <textarea ofeTextAreaInput></textarea>
 * ```
 *
 * See the [vanilla carbon docs](http://www.carbondesignsystem.com/components/text-input/code) for more detail.
 */
export declare class TextAreaDirective {
    /**
     * `light` or `dark` input theme
     */
    theme: 'light' | 'dark';
    baseClass: boolean;
    customClass: boolean;
    invalid: boolean;
    skeleton: boolean;
    get isLightTheme(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<TextAreaDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TextAreaDirective, "[ofeTextAreaInput]", never, { "theme": { "alias": "theme"; "required": false; }; "invalid": { "alias": "invalid"; "required": false; }; "skeleton": { "alias": "skeleton"; "required": false; }; }, {}, never, never, false, never>;
}
