import { ChangeDetectorRef, ComponentRef, ElementRef, EmbeddedViewRef, EventEmitter } from '@angular/core';
import { AnimationEvent } from '@angular/animations';
import { FocusTrapFactory } from '@angular/cdk/a11y';
import { BasePortalOutlet, CdkPortalOutlet, ComponentPortal, TemplatePortal } from '@angular/cdk/portal';
import { OwlDialogConfig } from './dialog-config.class';
import * as i0 from "@angular/core";
export declare class OwlDialogContainerComponent extends BasePortalOutlet {
    private changeDetector;
    private elementRef;
    private focusTrapFactory;
    private document;
    get owlDialogContainerTabIndex(): number;
    get owlDialogContainerClass(): boolean;
    get owlDialogContainerId(): string;
    get owlDialogContainerRole(): "dialog" | "alertdialog";
    get owlDialogContainerAriaLabelledby(): string;
    get owlDialogContainerAriaDescribedby(): string;
    get owlDialogContainerAnimation(): {
        value: "void" | "enter" | "exit";
        params: any;
    };
    onAnimationStart(event: AnimationEvent): void;
    onAnimationDone(event: AnimationEvent): void;
    portalOutlet: CdkPortalOutlet;
    /** The class that traps and manages focus within the dialog. */
    private focusTrap;
    /** ID of the element that should be considered as the dialog's label. */
    ariaLabelledBy: string | null;
    /** Emits when an animation state changes. */
    animationStateChanged: EventEmitter<AnimationEvent>;
    isAnimating: boolean;
    private _config;
    get config(): OwlDialogConfig;
    private state;
    private params;
    private elementFocusedBeforeDialogWasOpened;
    constructor(changeDetector: ChangeDetectorRef, elementRef: ElementRef, focusTrapFactory: FocusTrapFactory, document: any);
    /**
     * Attach a ComponentPortal as content to this dialog container.
     */
    attachComponentPortal<T>(portal: ComponentPortal<T>): ComponentRef<T>;
    attachTemplatePortal<C>(portal: TemplatePortal<C>): EmbeddedViewRef<C>;
    setConfig(config: OwlDialogConfig): void;
    startExitAnimation(): void;
    /**
     * Calculate origin used in the `zoomFadeInFrom()`
     * for animation purpose
     */
    private calculateZoomOrigin;
    /**
     * Save the focused element before dialog was open
     */
    private savePreviouslyFocusedElement;
    private trapFocus;
    private restoreFocus;
    static ɵfac: i0.ɵɵFactoryDeclaration<OwlDialogContainerComponent, [null, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<OwlDialogContainerComponent, "ofe-owl-dialog-container", never, {}, {}, never, never, false, never>;
}
