import { FormFactory } from './form.factory';
import { Form } from './form';
import { QuestionBase, RepeatingQuestion } from '../question-models/models';
import { AfeFormControl, AfeFormArray, AfeFormGroup } from '../../abstract-controls-extension';
import { TranslateService } from '@ngx-translate/core';
export interface ChildNodeCreatedListener {
    addChildNodeCreatedListener(func: any): any;
    fireChildNodeCreatedListener(node: GroupNode): any;
}
export type CreateArrayChildNodeFunction = (question: RepeatingQuestion, node: ArrayNode, factory?: FormFactory, position?: number) => GroupNode;
export interface RemoveArrayChildNodeFunction {
    (index: number, node: ArrayNode): any;
}
export declare abstract class NodeBase {
    abstract children?: any;
    nodeIndex?: Number;
    private _control;
    private _questionModel;
    private _form;
    private _path;
    initialValue: any;
    constructor(question: QuestionBase, control?: AfeFormControl | AfeFormArray | AfeFormGroup, form?: Form, parentPath?: string);
    get question(): QuestionBase;
    get control(): AfeFormControl | AfeFormArray | AfeFormGroup;
    get form(): Form;
    get path(): string;
    removeAt(index: number): void;
    createChildNode(): void;
    removeChildNode(): void;
}
export declare class LeafNode extends NodeBase {
    get children(): any;
    constructor(question: QuestionBase, control?: AfeFormControl | AfeFormArray | AfeFormGroup, parentControl?: AfeFormControl | AfeFormArray | AfeFormGroup, form?: Form, parentPath?: string);
}
export declare class GroupNode extends NodeBase {
    private _children;
    constructor(question: QuestionBase, control?: AfeFormControl | AfeFormArray | AfeFormGroup, parentControl?: AfeFormControl | AfeFormArray | AfeFormGroup, form?: Form, parentPath?: string);
    get children(): any;
    setChild(key: string, node: NodeBase): void;
}
export declare class ArrayNode extends NodeBase implements ChildNodeCreatedListener {
    translate: TranslateService;
    private formFactory?;
    private childNodeCreatedEvents;
    private _children;
    createChildFunc: CreateArrayChildNodeFunction;
    removeChildFunc: RemoveArrayChildNodeFunction;
    constructor(question: QuestionBase, translate: TranslateService, control?: AfeFormControl | AfeFormArray | AfeFormGroup, parentControl?: AfeFormControl | AfeFormArray | AfeFormGroup, formFactory?: FormFactory, form?: Form, parentPath?: string);
    get children(): GroupNode[];
    createChildNode(): GroupNode;
    removeAt(index: number): GroupNode;
    addChildNodeCreatedListener(func: any): void;
    fireChildNodeCreatedListener(node: GroupNode): void;
}
