import { FormFactory } from './form.factory';
import { QuestionFactory } from './question.factory';
import { DataSources } from '../data-sources/data-sources';
import { NodeBase, GroupNode } from './form-node';
import { Diagnosis } from '../value-adapters/diagnosis.adapter';
export declare class Form {
    schema: any;
    formFactory: FormFactory;
    questionFactory: QuestionFactory;
    rootNode: GroupNode;
    valueProcessingInfo: any;
    existingOrders: any;
    existingDiagnoses: Array<Diagnosis>;
    private _dataSourcesContainer;
    private _showErrors;
    constructor(schema: any, formFactory: FormFactory, questionFactory: QuestionFactory);
    get dataSourcesContainer(): DataSources;
    searchNodeByPath(node: GroupNode, path: any, found: Array<NodeBase>): NodeBase[];
    searchNodeByQuestionId(questionId: string, questionType?: string): Array<NodeBase>;
    searchNodeByQuestionType(rootNode: any, questionType: string, found: Array<NodeBase>): void;
    private findNodesByQuestionId;
    get valid(): boolean;
    set showErrors(show: boolean);
    get showErrors(): boolean;
    markInvalidControls(node: GroupNode, invalidControlNodes?: any): any;
    updateHiddenDisabledStateForAllControls(): void;
    updateAlertsForAllControls(): void;
    private _updateAlertsForAllControls;
    private _updateHiddenDisabledStateForAllControls;
}
