import { TranslateService } from '@ngx-translate/core';
import { LeafNode, GroupNode, ArrayNode, NodeBase } from './form-node';
import { QuestionBase, NestedQuestion, RepeatingQuestion } from '../question-models/models';
import { FormControlService } from './form-control.service';
import { QuestionFactory } from './question.factory';
import { AfeFormGroup } from '../../abstract-controls-extension';
import { ControlRelationsFactory } from './control-relations.factory';
import { Form } from './form';
import * as i0 from "@angular/core";
export declare class FormFactory {
    controlService: FormControlService;
    questionFactroy: QuestionFactory;
    controlRelationsFactory: ControlRelationsFactory;
    translate: TranslateService;
    private nodeIndex;
    hd: any;
    constructor(controlService: FormControlService, questionFactroy: QuestionFactory, controlRelationsFactory: ControlRelationsFactory, translate: TranslateService);
    createForm(schema: any, dataSource?: any): Form;
    buildRelations(rootNode: GroupNode): void;
    createNode(question: QuestionBase | NestedQuestion, parentNode?: GroupNode, parentControl?: AfeFormGroup, form?: Form): NodeBase;
    createLeafNode(question: QuestionBase, parentNode: GroupNode, parentControl?: AfeFormGroup, form?: Form): LeafNode;
    createGroupNode(question: NestedQuestion, parentNode?: GroupNode, parentControl?: AfeFormGroup, form?: Form): GroupNode;
    createArrayNode(question: NestedQuestion, parentNode?: GroupNode, parentControl?: AfeFormGroup, form?: Form): ArrayNode;
    createNodeChildren(question: NestedQuestion, node: GroupNode, parentControl?: AfeFormGroup, form?: Form): any;
    createArrayNodeChild(question: RepeatingQuestion, node: ArrayNode, factory?: FormFactory, position?: number): GroupNode;
    removeArrayNodeChild(index: number, node: ArrayNode): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormFactory, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FormFactory>;
}
