import { TranslateService } from '@ngx-translate/core';
import { ConditionalRequiredValidator } from '../validators/conditional-required.validator';
import { ConditionalAnsweredValidator } from '../validators/conditional-answered.validator';
import { JsExpressionValidator } from '../validators/js-expression.validator';
import { QuestionBase } from '../question-models/question-base';
import { DisallowDecimalsValidator } from '../validators/disallow-decimals.validator';
import * as i0 from "@angular/core";
export declare class ValidationFactory {
    private translate;
    constructor(translate: TranslateService);
    getValidators(question: QuestionBase, form?: any): any[];
    get conditionalRequiredValidator(): ConditionalRequiredValidator;
    get conditionalAnsweredValidator(): ConditionalAnsweredValidator;
    get disallowDecimalsValidator(): DisallowDecimalsValidator;
    get requiredValidator(): any;
    get dateValidator(): any;
    get futureDateRestrictionValidator(): any;
    get maxDateValidator(): any;
    get minDateValidator(): any;
    minLengthValidator(minLength: number): (control: import("@openmrs/ngx-formentry").AfeFormControl) => {
        [key: string]: any;
    };
    maxLengthValidator(maxLength: number): (control: import("@openmrs/ngx-formentry").AfeFormControl) => {
        [key: string]: any;
    };
    getMinValueValidator(min: number): any;
    getMaxValueValidator(max: number): any;
    getDisallowedDecimalsValidator(): (control: import("@openmrs/ngx-formentry").AfeFormControl) => {
        [key: string]: any;
    };
    get jsExpressionValidator(): JsExpressionValidator;
    errors(errors: any, question: QuestionBase): Array<string>;
    static ɵfac: i0.ɵɵFactoryDeclaration<ValidationFactory, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ValidationFactory>;
}
