import { OnInit, OnChanges, SimpleChanges, TemplateRef } from '@angular/core';
import { DataSources } from '../data-sources/data-sources';
import { NodeBase, LeafNode } from '../form-factory/form-node';
import { AfeFormGroup } from '../../abstract-controls-extension/afe-form-group';
import { ValidationFactory } from '../form-factory/validation.factory';
import { DataSource } from '../question-models/interfaces/data-source';
import { FormErrorsService } from '../services/form-errors.service';
import { TranslateService } from '@ngx-translate/core';
import * as i0 from "@angular/core";
export declare class FormRendererComponent implements OnInit, OnChanges {
    private validationFactory;
    private dataSources;
    private formErrorsService;
    translate: TranslateService;
    private document;
    formSubmissionTemplate: TemplateRef<unknown>;
    parentComponent: FormRendererComponent;
    node: NodeBase;
    parentGroup: AfeFormGroup;
    theme: string;
    labelMap: Object;
    controlId: String;
    childComponents: FormRendererComponent[];
    showTime: boolean;
    showWeeks: boolean;
    activeTab: number;
    dataSource: DataSource;
    isCollapsed: boolean;
    auto: any;
    followFocus: boolean;
    cacheActive: boolean;
    isNavigation: boolean;
    type: string;
    hasMultiplePages: boolean;
    inlineDatePicker: Date;
    private TAB_SELECTION_DELAY_MS;
    constructor(validationFactory: ValidationFactory, dataSources: DataSources, formErrorsService: FormErrorsService, translate: TranslateService, document: Document);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    addChildComponent(child: FormRendererComponent): void;
    setUpRemoteSelect(): void;
    setUpFileUpload(): void;
    loadLabels(): void;
    checkSection(node: NodeBase): boolean;
    clickTab(tabNumber: number): void;
    loadPreviousTab(): void;
    isCurrentTabFirst(): boolean;
    isCurrentTabLast(): boolean;
    loadNextTab(): void;
    tabSelected($event: any): void;
    setPreviousTab(): void;
    hasErrors(): boolean;
    errors(): string[];
    scrollToControl(error: string): void;
    onDateChanged(node: LeafNode): void;
    upload(event: any): void;
    toggleInformation(infoId: any): void;
    private getErrors;
    showErrors(): boolean;
    get errorNodes(): any;
    getControlError(node: LeafNode): string[];
    announceErrorField(errorNode: LeafNode): void;
    getPageIndex(node: NodeBase): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormRendererComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FormRendererComponent, "ofe-form-renderer", never, { "formSubmissionTemplate": { "alias": "formSubmissionTemplate"; "required": false; }; "parentComponent": { "alias": "parentComponent"; "required": false; }; "node": { "alias": "node"; "required": false; }; "parentGroup": { "alias": "parentGroup"; "required": false; }; "theme": { "alias": "theme"; "required": false; }; "labelMap": { "alias": "labelMap"; "required": false; }; "controlId": { "alias": "controlId"; "required": false; }; }, {}, never, never, false, never>;
}
