import { Form } from '../form-factory/form';
import { ValueAdapter } from './value.adapter';
import { GroupNode } from '../form-factory/form-node';
import * as i0 from "@angular/core";
export declare class DiagnosisValueAdapter implements ValueAdapter {
    formDiagnosisNodes: any[];
    generateFormPayload(form: Form): DiagnosisPayload[];
    populateForm(form: Form, diagnoses: Array<Diagnosis>): void;
    private _createDiagnosesPayload;
    private _createPayloadDiagnosis;
    private _getDeletedDiagnoses;
    private _updatedOldDiagnoses;
    private _setDiagnosesValues;
    private setDiagnosisGroupValue;
    private _findDiagnosisQuestionNodes;
    private _convert;
    hasDiagnosisNodeChanged(nodeAsGroup: GroupNode): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<DiagnosisValueAdapter, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DiagnosisValueAdapter>;
}
export interface Diagnosis {
    uuid?: string;
    display?: string;
    encounter?: string;
    patient?: string;
    diagnosis: {
        coded?: {
            uuid: string;
            display?: string;
        };
        nonCoded?: string;
    };
    certainty: 'CONFIRMED' | 'PROVISIONAL';
    rank: number;
    voided?: boolean;
}
export interface DiagnosisPayload {
    uuid?: string;
    encounter?: string;
    patient?: string;
    diagnosis: {
        coded?: string;
        nonCoded?: string;
    };
    certainty: 'CONFIRMED' | 'PROVISIONAL';
    rank: number;
    voided?: boolean;
}
